/* config.h.  Generated automatically by configure.  */
/****************************************************************************

  Copyright (c) 1999,2000,2001 WU-FTPD Development Group.
  All rights reserved.

  Portions Copyright (c) 1980, 1985, 1988, 1989, 1990, 1991, 1993, 1994
    The Regents of the University of California.
  Portions Copyright (c) 1993, 1994 Washington University in Saint Louis.
  Portions Copyright (c) 1996, 1998 Berkeley Software Design, Inc.
  Portions Copyright (c) 1989 Massachusetts Institute of Technology.
  Portions Copyright (c) 1998 Sendmail, Inc.
  Portions Copyright (c) 1983, 1995, 1996, 1997 Eric P.  Allman.
  Portions Copyright (c) 1997 by Stan Barber.
  Portions Copyright (c) 1997 by Kent Landfield.
  Portions Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996, 1997
    Free Software Foundation, Inc.

  Use and distribution of this software and its source code are governed
  by the terms and conditions of the WU-FTPD Software License ("LICENSE").

  If you did not receive a copy of the license, it may be obtained online
  at http://www.wu-ftpd.org/license.html.

  $Id: config.h.in,v 1.29 2002/02/14 18:52:35 wuftpd Exp $

****************************************************************************/

/*
 * Top level config file... These values will be adjusted by autoconf.
 * $Id: config.h.in,v 1.29 2002/02/14 18:52:35 wuftpd Exp $
 */

/*
 * allow "upload" keyword in ftpaccess
 */

#define UPLOAD 1

/*
 * allow "overwrite" keyword in ftpaccess.
 */

#define OVERWRITE 1

/*
 * allow "allow/deny" for individual users.
 */

#define HOST_ACCESS 1

/*
 * log failed login attempts
 */

//#define LOG_FAILED 1

/*
 * log login attempts that fail because of class connection
 * limits.  Busy servers may want to prevent this logging
 * since it can fill up the log file and put a high load on
 * syslog.
 */
#define LOG_TOOMANY 1

/*
 * allow use of private file.  (for site group and site gpass)
 * NO_PRIVATE
 * Define this if you don't want to use the private authentication databases.
 */

#define NO_PRIVATE 1

/*
 * Try once more on failed DNS lookups (to allow far away connections
 * which might resolve slowly)
 */

/* #undef	DNS_TRYAGAIN */

/*
 * ANON_ONLY
 * Permit only anonymous logins... disables all other type
 */

/* #undef ANON_ONLY */

/*
 * PARANOID
 * Disable "questionable" functions
 */

/* #undef PARANOID */

/*
 * Better PARANOID options.
 * Allows finer control than PARANOID.
 * See README.paranoid for more information on these options.
 *
 * 2000/07/15 Sylvain Robitaille: The following defaults are "somewhat
 *                                paranoid".  Defining PARANOID will
 *                                result in the following, which
 *                                emulates known behaviour:
 *
 *            #undef  ENABLE_DELETE
 *            #undef  ENABLE_OVERWRITE
 *            #undef  DISABLE_STRICT_HOMEDIR
 *            #define DISABLE_SITE 1
 */

#define ENABLE_DELETE 1
#define ENABLE_OVERWRITE 1
/* #undef DISABLE_STRICT_HOMEDIR */

/* #undef DISABLE_SITE_UMASK */
/* #undef DISABLE_SITE_CHMOD */
/* #undef DISABLE_SITE_IDLE */
/* #undef  ENABLE_SITE_EXEC */
/* #undef DISABLE_SITE_ALIAS */
/* #undef DISABLE_SITE_GROUPS */
/* #undef DISABLE_SITE_CDPATH */
/* #undef DISABLE_SITE_CHECKMETHOD */
/* #undef DISABLE_SITE_CHECKSUM */
/* #undef DISABLE_SITE */

/*
 * USE_LASTLOG
 * Track logins via lastlog file.
 * 2000/10/19 Sylvain Robitaille
 */

//#define USE_LASTLOG 1

/*
 * SKEY
 * Add SKEY support -- REQUIRES S/Key libraries
 *
 * If you wish to use some S/Key libraries such as
 * <URL:http://www.sparc.spb.su/solaris/skey/> then you will need to define
 * the variable SKEY_RFC2289 in addition to the variable SKEY.
 */

/* #undef SKEY */
/* #undef SKEY_RFC2289 */

/*
 * OPIE
 * One-time Passwords In Everything (OPIE)
 * Add OPIE support -- REQUIRES OPIE libraries
 */

#if !defined (LINUX)		/* Linux autodetects OPIE */
/* #undef OPIE */
#endif

/*
 * ALTERNATE_CD
 * Causes "cd ~" to return the chroot-relative directory instead of the
 * real directory.
 */
#define ALTERNATE_CD 1

/*
 * UNRESTRICTED_CHMOD
 * If defined, any valid value for the mode will be accepted.
 * Otherwise, only values between 0 and 777 are accepted.
 */
/* #undef UNRESTRICTED_CHMOD */

/*
 * USE_RFC931
 * Define this if you want to use RFC 931 'authentication' - this improves
 * the logging at the cost of a possible slight delay in connection.
 */
/* #undef USE_RFC931 */

/*
 * BASE_HOMEDIR
 * You can specify a directory under which real users' home directories
 * must reside. Logins will be refused if the home directory is not
 * below the directory specified here.
 */

/* #undef BASE_HOMEDIR */

/*
 * ALT_HOMEDIR
 * You can specify a directory to which real users may still login if
 * their own home directory fails either the STRICT_HOMEDIR or the
 * BASE_HOMEDIR test.
 */
/* #undef ALT_HOMEDIR */

/*
 * BUFFER_SIZE
 * You can specify the buffer size for binary transfers; the defaults
 * are often far too small for efficiency.
 */
/* #undef BUFFER_SIZE */

/*
 * If you want to specify the syslog facility, you should modify CFLAGS in
 * the appropriate src/makefile/Makefile.*.
 */

/* If you want to set the paths where the configuration files, pids and logs
 * are stored, you should inspect src/pathnames.h and modify the appropriate
 * src/config/config.*.
 */

/*
 * RATIO
 * Support for Upload/Download ratios (may download x bytes for uploading 1 byte)
 */
/* #undef RATIO */

/*
 * OTHER_PASSWD
 * Support for using alternative passwd/shadow files
 */
#define OTHER_PASSWD 1

/*
 * DAEMON
 * If ftpd called with -s or -S then run as a standalone daemon listening on
 * the ftp port.  This can speed up ftpd response as all ftpd then needs to
 * do is fork off a copy to handle an incoming request.  Under inetd
 * a new copy has to be opened and exec'd.
 */
#define DAEMON 1

/*
 * MAX_BACKLOG
 * Only used in DAEMON mode.
 * This is second parameter to listen.  It defines the number of incoming
 * processes to allow to backlog, prior to being accept() processing them,
 * before rejecting.
 */
#define MAX_BACKLOG 100

/*
 * MAPPING_CHDIR
 * Keep track of the path the user has chdir'd into and respond with
 * that to pwd commands.  This is to avoid having the absolute disk
 * path returned.  This helps avoid returning dirs like '.1/fred'
 * when lots of disks make up the ftp area.
 */

#define MAPPING_CHDIR 1

/*
 * THROUGHPUT
 * Keep track of total throughput for the user and limit if required.
 */

//#define THROUGHPUT 1

/*
 * TRANSFER_COUNT
 * Keep track of total bytes for statistics.
 */

//#define TRANSFER_COUNT 1

/*
 * TRANSFER_LIMIT
 * Limit file and bytes transferred in a session.
 */

//#define TRANSFER_LIMIT 1

/*
 * HOST_LIMIT
 * Limit number of simultaneous connections from a given host IP address.
 */

//#define HOST_LIMIT 1

/*
 * NO_SUCKING_NEWLINES
 * Don't suppress some extra blank lines on messages and banners.
 */

/* #undef NO_SUCKING_NEWLINES */

/*
 * HELP_CRACKERS
 * Define this to help crackers break into your system by letting them
 * figure out which user names exist to guess passwords on.
 */

/* #undef HELP_CRACKERS */

/*
 * VERBOSE_ERROR_LOGING
 * Log all problems with USER and PASS as well as all rejected commands
 * and denied uploads/downloads.
 */

//#define VERBOSE_ERROR_LOGING 1

/*
 * IGNORE_NOOP
 * Undefine this to let NOOP reset the idle timeout.
 */

#define IGNORE_NOOP 1

/*
 * XFERLOG_REALPATH
 * Define this to log the real path rather than the chroot-relative path for
 * files named in the xferlog.
 */

//#define XFERLOG_REALPATH 1

/*
 * CLOSED_VIRTUAL_SERVER
 * Undefine this to allow real and non-owner guests to log in on a virtual
 * server's address.
 */
#define CLOSED_VIRTUAL_SERVER 1

/*
 * NO_DNS
 * Define this to skip DNS lookups.  If the remote host name is needed, the
 * daemon uses the IP numbers instead.  'deny !nameserved' will always be
 * true (denying access) if this patch is enabled.
 *
 * This option is intended solely for very busy FTP sites where the added
 * security of DNS lookups is overshadowed by the speed and resource penalties.
 *
 * Disabling DNS lookups removes all protections against spoofing, making
 * remote user authentication virtually useless.  This option should only be
 * used on anonymous FTP servers.
 *
 * If you're not *absolutely sure* you need this, don't enable it.
 */
/* #undef NO_DNS */

#define NO_DNS 1

/*
 * Some people don't like PASV and want to disable it.  Whatever.
 * PORT can be abused to attack other hosts.  Let's give the option to
 * disable one or the other.  We'll ignore DISABLE_PASV if you defined
 * DISABLE_PORT (hey, you gotta have at least one!).
 */
/* #undef DISABLE_PORT */
/* #undef DISABLE_PASV */

/*
 * Define this to suppress messages about PID locks causing the daemon to
 * sleep.  This should only be needed at busy sites.
 */
/* #undef NO_PID_SLEEP_MSGS */

/*
 * Define this to require the remove end of a PASV connection to have the
 * same IP as the control connection.  This limits, but does not eliminate,
 * the risk of PASV port race stealing the connection.  It also is non-RFC
 * compliant, so it may cause problems for some client sites.
 */
#define FIGHT_PASV_PORT_RACE 1

/*
 * Define this to completely disable anonymous FTP access.
 */
#define NO_ANONYMOUS_ACCESS 1

/*
 * Define this to have an ls command compiled into the daemon. That way you
 * don't need to put statically linked ls's into every chroot directory.
 */
#define INTERNAL_LS 1

/*
 * Define this if you want the internal ls to display UIDs/GIDs rather than
 * user/group names. This is faster, but doesn't look as nice.
 */
#define LS_NUMERIC_UIDS 1

/*
 * Define this if you want to hide setuid bits in the internal ls
 * this might be a good idea for security.
 */
#define HIDE_SETUID 1

/*
 * Undefine this if you don't want the enhanced DNS (resolver) features;
 * or if you cannot find libresolv on your system.
 */
#define HAVE_LIBRESOLV 1

/*
 * Define this if you want to support virtual servers
 */
//#define VIRTUAL 1

/*
 * Define this if you want to be able to receive mail on anonymous
 * uploads
 */
//#define MAIL_ADMIN 1

/*
 * Config files in /etc by default
 */
#define USE_ETC 1

/*
 * Define this to support quota mechanisms...
 */
/* #undef QUOTA */

/*
 * Define this to support broken clients
 */
/* #undef SUPPORT_BROKEN_CLIENTS */

/*
 * Define this to revert the NLST command to showing directories.
 *
 * This will cause mget to have errors when it attempts to RETR the
 * directory name (which is not a RETRievable object) but will revert
 * the NLST command enough to quell complains from Solaris command-
 * line FTP client users.
 */
/* #undef NLST_SHOWS_DIRS */

/*
 * Define this to enable logging of restart position and file size.  Warning:
 * This may break some scripts using the xferlog, as there are 2 new fields
 */
/* #undef RESTART_LOGGING */

/*
 * Using tcpwrappers (libwrap) in standalone daemon mode.
 *
 * Define LIBWRAP.  If you're using configure, edit src/Makefile
 * to add -lwrap to the ftpd step.  If you're using build, edit
 * src/makefiles/common or the Makefile specific to your system.
 */
/* #undef LIBWRAP */

/*
 * Define this to include IPv6, RFC 1639 (LPRT/LPSV) and RFC 2428 (EPRT/EPSV)
 * support.
 */
/* #undef INET6 */

/*
 * Define this when the struct sockaddr_storage has a __ss_family member
 * instead of ss_family (eg Linux)
 *
 */
/* #undef HAVE__SS_FAMILY */

/*
 * Define this when the struct sockaddr_in6 has a member sin6_scope_id
 * (Solaris 8 at the moment)
 */

/* #undef HAVE_SIN6_SCOPE_ID */

/*
 * support AUTH TLS etc... (requires OpenSSL) FORCE_TLS will disable command
 * line options to disable TLS (I.E. the binary will not support insecure
 * connections)
 */
/* #undef USE_TLS */
/* #undef FORCE_TLS */
/* #undef TLS_DEBUG */

/*
 * Define if snprintf() returns the number of bytes it wants to write in case
 * of overflow
 */
#define SNPRINTF_OK 1

/*
 * Define if snprintf() returns the number of bytes written (excl. \0) in case
 * of overflow
 */
/* #undef SNPRINTF_HALFBROKEN */

/*
 * Define if snprintf() returns -1 in case of overflow
 */
/* #undef SNPRINTF_BROKEN */

/*
 * Character used to pad process title
 */
#define SPT_PADCHAR '\0'

/* #undef HAVE_LOGIN_H */
